// Chess diagram drawing JavaScript
// Written by Milan Velimirovic, e-mail: mivel@sezampro.yu

//=================================================
// Draw the diagram
//	str = MatPlus type shortened Forsyth notation (English)

function diagx(str)
{
 document.write("<table border=1 cellpadding=0 cellspacing=0 bordercolor=#000000><tr><td nowrap>\r\n");
 var j = str.length;
 var empty = 0;
 var ch, e;
 var c=0;
 var c1;
 var dlm=0;
 var rest = 64;
 var br = 0;
 var err = 0;
 var neutral="";
 var rot="";
 for (i=0; i<j+1; i++) {
  ch = str.charAt(i);
  if (ch>='0' && ch<='9') empty = empty * 10 + parseInt(ch);
  else if (ch=='!') neutral='N';
  else if (ch=='*') {
   if (rot=="") rot='1';
   else if (rot=='1') rot='2';
   else if (rot=='2') rot='3';
  }
  else {
   if (i>=j) empty=rest;
   while (empty>0) {
    e = 8-br;
    if (e>empty) e=empty;
    document.write('<IMG SRC="');
    if (e>1) document.write(e);
    document.write(c + '.GIF"' + '>');
    empty -= e;
    br = (br+e) & 7;
    c = (c+e+1) & 1;
    if (br==0 && i<60) document.write("<br>\r\n");
    else c ^= 1;
    rest -= e;
   }
   if (i<j) {
    document.write('<IMG SRC="');
     switch (ch) {
     case 'K': case 'Q': case 'R': case 'B': case 'S': case 'P': 
      document.write(neutral + ch + c + rot);
      break;
     case 'k': case 'q': case 'r': case 'b': case 's': case 'p': 
      if (neutral=="") c1 = c+2;
      else c1=c;
      document.write(neutral + ch.toUpperCase() + c1 + rot);
      break;
     default:
      document.write("ER");
      err=1;
     }
     document.write('.GIF"' + '>');
     br = ++br & 7;
     if (br==0 && i<60) document.write("<br>\r\n");
     else c ^= 1;
     rest--; 
     rot="";
     neutral="";
    }
   }
 }
 document.write("</td></tr></table>\r\n");
}

function setLeft(url) {
	var s = top.dia.location.href;
	var s1="";
	var i=0;
	var j=0;
	var k=s.length;
	while (i<k)
		if (s.charAt(i++)=='/') j=i;
	while (j<k) 
		s1 += s.charAt(j++);
	if (s1 != url) 
		top.dia.location.replace(url);
}

// for WCCT
function pr(aut, pos, cond, extra, sum)
{
	var s = aut.charAt(0);
	document.write("<b><a href='" + s + "S.html#" + aut + "' target='sol'>");
	document.write(aut +"</a></b><br>\r\n");
	diagx(pos);
	document.write("<table border=0 width=170><tr valign=top>\r\n<td>" + cond + "</td>\r\n<td align=center><small>" + extra + "</small></td>\r\n<td align=right>" + sum + "</td></tr></table>\r\n");
	document.write("\r\n");
}

//(Preload GIFs to speed-up interactive work!)
u = new Array(41);
for (i=0; i<41; i++)
	u[i]=new Image();
u[0].src="ER.GIF";
u[1].src="0.GIF";
u[2].src="1.GIF";
u[3].src="80.GIF";
u[4].src="81.GIF";
u[5].src="B0.GIF";
u[6].src="B1.GIF";
u[7].src="B2.GIF";
u[8].src="B3.GIF";
u[9].src="K0.GIF";
u[10].src="K1.GIF";
u[11].src="K2.GIF";
u[12].src="K3.GIF";
u[13].src="P0.GIF";
u[14].src="P1.GIF";
u[15].src="P2.GIF";
u[16].src="P3.GIF";
u[17].src="Q0.GIF";
u[18].src="Q1.GIF";
u[19].src="Q2.GIF";
u[20].src="Q3.GIF";
u[21].src="R0.GIF";
u[22].src="R1.GIF";
u[23].src="R2.GIF";
u[24].src="R3.GIF";
u[25].src="S0.GIF";
u[26].src="S1.GIF";
u[27].src="S2.GIF";
u[28].src="S3.GIF";
u[29].src="20.GIF";
u[30].src="21.GIF";
u[31].src="30.GIF";
u[32].src="31.GIF";
u[33].src="40.GIF";
u[34].src="41.GIF";
u[35].src="50.GIF";
u[36].src="51.GIF";
u[37].src="60.GIF";
u[38].src="61.GIF";
u[39].src="70.GIF";
u[40].src="71.GIF";
